using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Sdgt;

namespace SdgtExample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Sdgt.SdgManager sdgManager1;
		
		private System.ComponentModel.IContainer components;
		private ToolGlass toolglass;
		private Pen CurrentPen;
		private Point LastPoint;
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			
			InitializeComponent();
			
			CurrentPen = new Pen(new SolidBrush(Color.Black), 3);

			toolglass = new ToolGlass(0);
			toolglass.Show();
			toolglass.ColourChanged += new EventHandler(toolglass_ColourChanged);
			sdgManager1.AttachEventSinkWidget(toolglass, toolglass);
			LastPoint = new Point(sdgManager1.Mice[0].X, sdgManager1.Mice[0].Y);
			sdgManager1.Mice[1].Visible = false;
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.sdgManager1 = new Sdgt.SdgManager(this.components);
			// 
			// sdgManager1
			// 
			this.sdgManager1.EmulateSystemMouseMode = Sdgt.EmulateSystemMouseModes.Park;
			this.sdgManager1.Keyboards = null;
			this.sdgManager1.Mice = null;
			this.sdgManager1.MouseToFollow = 0;
			this.sdgManager1.ParkSystemMouseLocation = new System.Drawing.Point(350, 350);
			this.sdgManager1.RelativeTo = this;
			this.sdgManager1.MouseMove += new Sdgt.SdgMouseEventHandler(this.sdgManager1_MouseMove);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Name = "Form1";
			this.Text = "Form1";

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void sdgManager1_MouseMove(object sender, Sdgt.SdgMouseEventArgs e)
		{
			if (e.ID == 0)
			{
				if (MouseButtons.Left == e.Button)
				{
					Graphics g = this.CreateGraphics();
					g.DrawLine(CurrentPen, new Point(e.X, e.Y), LastPoint);
				}
				LastPoint = new Point(e.X, e.Y);
			}
			else
			{
				toolglass.Location = new Point(sdgManager1.Mice[e.ID].Xabs, sdgManager1.Mice[e.ID].Yabs);
			}
		}

		private void toolglass_ColourChanged(object sender, EventArgs e)
		{
			CurrentPen.Color = toolglass.SelectedColour;
		}
	}
}
